routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\ClienteController;
use App\Http\Controllers\TiposDocumentoController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', function () {
    return view('inicial');
});
Route::resource('cliente',ClienteController::class);
Route::get('tiposdocumento/{id}', [TiposDocumentoController::class,'listar'])->name('tiposdocumento.listar');

app/Models/Cliente.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Cliente extends Model
{
    use HasFactory;
    protected $fillable=[
    'placa',
    'tipo_documento_id',
    'numero_documento',
    'nombre',
    'apellido',
    'telefono',
    'fecha_nacimiento'];
    public function tipo_documento()
    {
        return $this->belongsTo(TiposDocumento::class,'tipo_documento_id' , 'id');
    }
}

app/Models/Tarifa.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Tarifa extends Model
{
    use HasFactory;
}

app/Models/TiposDocumento.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class TiposDocumento extends Model
{
    use HasFactory;
    protected $fillable=['descripcion'];
    public function clientes() {
        return $this->hasMany(Cliente::class,'tipo_documento_id' , 'id');
    }
}

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password' => 'hashed',
    ];
}

app/Http/Controllers/ClienteController.php
<?php

namespace App\Http\Controllers;

use App\Models\Cliente;
use Illuminate\Http\Request;

class ClienteController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        
        $clientes = Cliente::all();
        return view('cliente.index', [
            'clientes' => $clientes
        ]);
        


    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
       return view('cliente.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        $input = $request->all();
        
        return redirect()->route('cliente.index');
        
    
    }

    /**
     * Display the specified resource.
     */
    public function show(Cliente $cliente)
    {
        return view('cliente.show',[
            'cliente' => $cliente
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Cliente $cliente)
    {
        return view('cliente.edit',[
            'cliente' => $cliente
        ]);
        
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Cliente $cliente)
    {
        $input = $request->all();
        $cliente->update($input);
        return  view('cliente.show', [
            'cliente' => $cliente
        ]);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Cliente $cliente)
    {
        $cliente->delete();
        return redirect()->route('cliente.index');

    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, ValidatesRequests;
}

app/Http/Controllers/TarifaController.php
<?php

namespace App\Http\Controllers;

use App\Models\Tarifa;
use Illuminate\Http\Request;

class TarifaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     */
    public function show(Tarifa $tarifa)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Tarifa $tarifa)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Tarifa $tarifa)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Tarifa $tarifa)
    {
        //
    }
}

app/Http/Controllers/TiposDocumentoController.php
<?php

namespace App\Http\Controllers;

use App\Models\TiposDocumento;
use Illuminate\Http\Request;

class TiposDocumentoController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     */
    public function show(TiposDocumento $tiposDocumento)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(TiposDocumento $tiposDocumento)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, TiposDocumento $tiposDocumento)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(TiposDocumento $tiposDocumento)
    {
        //
    }
    public function listar($id)
    {
        $tipo_documento=TiposDocumento::find($id);
        
        return view('cliente.listado',[
            'tipo_documento'=>$tipo_documento,
            'clientes'=>$tipo_documento->clientes
        ]);
    }
}

resources/views/cliente/create.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>

    <form action="{{route('cliente.store')}}" method="POST">
        @csrf
        <div>
        <label for="placa">Placa</label>
        <input type="text" name="placa" id="placa">
        <label for="tipo_documento_id">Tipo Documento</label>
        <input type="number" name="tipo_documento_id" id="tipo_documento_id">
        <label for="numero_documento">Numero Documento</label>
        <input type="number" name="numero_documento" id="numero_documento">
    </div>
    <div>
        <label for="nombre">Nombre</label>
        <input type="text" name="nombre" id="nombre">
        <label for="apellido">Apellido</label>
        <input type="text" name="apellido" id="apellido">
        <label for="telefono">Telefono</label>
        <input type="number" name="telefono" id="telefono">
        <label for="fecha_nacimiento">Fecha Nacimiento</label>
        <input type="date" name="fecha_nacimiento" id="fecha_nacimiento">
        
    </div>
    <div>
        <input type="submit" value="Registrar">
    </div>
    </form>
    
</body>
</html>

resources/views/cliente/edit.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>

    <form action="{{route('cliente.update',$cliente->id)}}" method="POST">
        @csrf
        @method('PUT')
        <div>
        <label for="placa">Placa</label>
        <input type="text" name="placa" id="placa" value="{{$cliente->placa}}">
        <label for="tipo_documento_id">Tipo Documento</label>
        <input type="number" name="tipo_documento_id" id="tipo_documento_id" value="{{$cliente->tipo_documento_id}}">
        <label for="numero_documento">Numero Documento</label>
        <input type="number" name="numero_documento" id="numero_documento" value="{{$cliente->numero_documento}}">
    </div>
    <div>
        <label for="nombre">Nombre</label>
        <input type="text" name="nombre" id="nombre" value="{{$cliente->nombre}}">
        <label for="apellido">Apellido</label>
        <input type="text" name="apellido" id="apellido" value="{{$cliente->apellido}}">
        <label for="telefono">Telefono</label>
        <input type="number" name="telefono" id="telefono" value="{{$cliente->telefono}}">
        <label for="fecha_nacimiento">Fecha Nacimiento</label>
        <input type="date" name="fecha_nacimiento" id="fecha_nacimiento" value="{{$cliente->fecha_nacimiento}}">
        
    </div>
    <div>
        <input type="submit" value="Actualizar">
    </div>
    </form>
    
</body>
</html>

resources/views/cliente/index.blade.php
@extends('layouts.app')

@section('content')
<h1>Listado de clientes</h1>
<div class="flex flex-col">
    <div class="overflow-x-auto sm:-mx-6 lg:-mx-8">
      <div class="inline-block min-w-full py-2 sm:px-6 lg:px-8">
        <div class="overflow-hidden">
          <table class="min-w-full text-left text-sm font-light">
            <thead class="border-b font-medium dark:border-neutral-500">
              <tr>
                <th scope="col" class="px-6 py-4">placa</th>
                <th scope="col" class="px-6 py-4">tipodocumento</th>
                <th scope="col" class="px-6 py-4">Numero Documento</th>    
                <th scope="col" class="px-6 py-4">nombre</th>
                <th scope="col" class="px-6 py-4">apellido</th>
                <th scope="col" class="px-6 py-4">telefono</th>
                <th scope="col" class="px-6 py-4">fecha nacimiento</th>

              </tr>
            </thead>
            <tbody>
                @foreach ($clientes as $cliente)
                <tr class="border-b dark:border-neutral-500">
                    <td class="whitespace-nowrap px-6 py-4">{{$cliente->placa}}</td>
                    <td class="whitespace-nowrap px-6 py-4">{{$cliente->tipo_documento->descripcion}}</td>
                    <td class="whitespace-nowrap px-6 py-4">{{$cliente->numero_documento}}</td>
                    <td class="whitespace-nowrap px-6 py-4">{{$cliente->nombre}}</td>
                    <td class="whitespace-nowrap px-6 py-4">{{$cliente->apellido}}</td>
                    <td class="whitespace-nowrap px-6 py-4">{{$cliente->telefono}}</td>
                    <td class="whitespace-nowrap px-6 py-4">{{$cliente->fechanacimiento}}</td>
                    <td><a href="{{route('cliente.show',$cliente->id)}}">Mostrar</a>
                        <a href="{{route('cliente.edit',$cliente->id)}}">Editar</a></td>
                    <td>
                        <form action="{{route('cliente.destroy',$cliente->id)}}" method="post">
                            @csrf
                            @method('DELETE')
                            <button type="submit">Eliminar</button>
                        </form>
                    </td>
                </tr>
                @endforeach
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </div>


<a href="{{route('cliente.create')}}">Registrar Cliente</a>
@endsection

resources/views/cliente/listado.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>

<h1>Listado de clientes con {{$tipo_documento->descripcion}}</h1>
<table>
    <tr>
        <th>placa</th>
        
        <th>Numero Documento</th>    
        <th>nombre</th>
        <th>apellido</th>
        <th>telefono</th>
        <th>fecha nacimiento</th>
    </tr>
@foreach ($clientes as $cliente)
<tr>
    <td>{{$cliente->placa}}</td>
    
    <td>{{$cliente->numero_documento}}</td>
    <td>{{$cliente->nombre}}</td>
    <td>{{$cliente->apellido}}</td>
    <td>{{$cliente->telefono}}</td>
    <td>{{$cliente->fechanacimiento}}</td>
    <td><a href="{{route('cliente.show',$cliente->id)}}">Mostrar</a>
        <a href="{{route('cliente.edit',$cliente->id)}}">Editar</a></td>
    <td>
        <form action="{{route('cliente.destroy',$cliente->id)}}" method="post">
            @csrf
            @method('DELETE')
            <button type="submit">Eliminar</button>
        </form>
    </td>
</tr>
@endforeach
</table>    
<a href="{{route('cliente.create')}}">Registrar Cliente</a>
</body>
</html>

resources/views/cliente/show.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>
    <ul>
        <li>Placa: {{$cliente->placa}}</li>
            <li>Tipo:{{$cliente->tipo_documento_id}}</li>
            <li>Doc:{{$cliente->numero_documento}}</li>
            <li>Nombre:{{$cliente->nombre}}</li>
            <li>Apellido{{$cliente->apellido}}</li>
            <li>Telefono:{{$cliente->telefono}}</li>
            <li>fecha:{{$cliente->fecha_nacimiento}}</li>
    </ul>
    <meta http-equiv="refresh" content="3; url={{route('cliente.index')}}" />

</body>
</html>

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <!-- Otras etiquetas head -->

    <!-- Agregar Tailwind CSS -->
    <link href="https://cdn.jsdelivr.net/npm/tailwindcss@2.2.15/dist/tailwind.min.css" rel="stylesheet">
    
</head>
<body class="font-sans bg-gray-100">
    <!-- Barra de navegación -->

    <nav class="bg-blue-500 p-4 text-white">
        <div class="container mx-auto">
            <h1 class="text-2xl font-bold">{{ config('app.name', 'Laravel') }}</h1>
        </div>
    </nav>

    <!-- Contenido principal -->
    <div class="container mx-auto p-4">
        @yield('content')
    </div>

    <!-- Agregar Tailwind CSS y JavaScript (opcional) -->
    <script src="{{ asset('js/app.js') }}"></script>
</body>
</html>